<template>
  <div class="container">
    <h2>New Skill</h2>
    <b-form-input
      v-model="name"
      required
      placeholder="skill name"
      type="text">
    </b-form-input>
    <b-form-input
      v-model="special_id"
      placeholder="special id"
      type="number">
    </b-form-input>
    <small>In case you don't know the special id, visit <nuxt-link to="/admin/specials">specials</nuxt-link></small>
    <b-form-input
      v-model="accuracy"
      placeholder="accuracy"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="cost_amount"
      placeholder="cost amount"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="cost_type"
      placeholder="cost type"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="ref_stat"
      placeholder="stat of reference"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      name: '',
      special_id: '',
      cost_amount: '',
      cost_type: '',
      ref_stat: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.name.length * this.special_id * (this.cost_amount+1) * (this.cost_type+1) * (this.ref_stat+1);
    }
  },
  methods: {
    submit() {
      let data = {
        skill: {
          name: this.name,
          special_id: this.special_id,
          cost_amount: this.cost_amount,
          cost_type: this.cost_type,
          ref_stat: this.ref_stat,
          accuracy: this.accuracy
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/skills',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
